/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Model;

import java.util.*;
import java.io.*;

/**
 *
 * @author moacir
 */
public class BookShelf {

    private ArrayList<Book> list;

    public BookShelf () {
        list = new ArrayList<Book>();
    }

    public void insertBook(String title, String author, int year ) {
        Book b1 = new Book(title,author,year);
        list.add(b1);
    }

    public void insertBook(Book b1) {
        list.add(b1);
    }

    public int numberOfBooks() {
        return list.size();
    }

    public void removeBook(int removecode) {
        Iterator<Book> it = list.iterator();

        while (it.hasNext()) {
            Book b1 = (Book)it.next();
            if (b1.getCode() == removecode)
                it.remove();
        }
    }

    public void removeBook(Book removebook) {
        Iterator<Book> it = list.iterator();

        while (it.hasNext()) {
            Book b1 = (Book)it.next();
            if (b1.equals(removebook))
                it.remove();
        }
    }

    public Iterator<Book> getListofBooks() {
        return list.iterator();
    }

    public int loadFromFile() {

      int regcount = 0;
      boolean repeat = false;

      do {
            repeat = false;
            
            File file = new File("/home/moacir/NetBeansProjects/BookList/Livros.txt");
            //Cria um FileReader para obter dados a partir de 'file'
            FileReader reader;
            //Cria um BufferReader para obter os seus dados a partir de um Reader
            BufferedReader br;

            try {
                reader = new FileReader(file);
                br = new BufferedReader(reader);

                while (br.ready()) {
                    String title_read;
                    String author_read;
                    int year_read;

                    title_read = br.readLine();
                    author_read = br.readLine();
                    year_read = (int)Integer.parseInt(br.readLine());

                    Book book_read = new Book(title_read,author_read,year_read);
                    insertBook(book_read);
                    regcount++;
                }
            }
            catch (FileNotFoundException ex) {
                Object[] options = {"Tentar novamente", "Sair"};
                int n = javax.swing.JOptionPane.showOptionDialog(null, "Arquivo nao encontrado",
                    "Erro", javax.swing.JOptionPane.YES_NO_OPTION, javax.swing.JOptionPane.QUESTION_MESSAGE,
                    null, options, options[1]);
                System.out.println("retorno: "+n);
                if (n == 1) {
                    ex.printStackTrace();
                    System.exit(1);
                } else {
                    repeat = true;
                }
            }
            catch (IOException ex) {
                ex.printStackTrace();
            }
      } while (repeat);

      return regcount;
    }

   public void fileWrite() {

        File file = new File("/home/moacir_ponti/NetBeansProjects/TresCamadas/Livros.txt");
        //Cria um FileReader para obter dados a partir de 'file'
        FileWriter writer = null;
        //Cria um BufferReader para obter os seus dados a partir de um Reader
        BufferedWriter bw = null;

        try {
            writer = new FileWriter(file);
            //Cria um objeto File e abre "src\\arquivos\\Dados.txt"
            bw = new BufferedWriter(writer);

            Iterator<Book> it = list.iterator();
            while (it.hasNext()) {
                Book bookwrite = it.next();
                bw.write(bookwrite.getTitle());
                bw.newLine();
                bw.write(bookwrite.getAuthor());
                bw.newLine();
                bw.write((String)""+bookwrite.getYear());
                bw.newLine();
                //Lê os dados do arquivo txt
                System.out.println("Book written: " + bookwrite.getDescription());
            }
        }
        catch(FileNotFoundException ex) {
             System.err.println("FileNotFoundException: " + ex.getMessage());
             //throw new SampleException(e);
        }
        catch(IOException ex) {
            ex.printStackTrace();
        }
        finally {
            //Close the BufferedWriter
            try {
                if (bw != null) {
                    bw.flush();
                    bw.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }


}
